"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = GitLab;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function GitLab(options) {
  return _objectSpread({
    id: "gitlab",
    name: "GitLab",
    type: "oauth",
    version: "2.0",
    scope: "read_user",
    params: {
      grant_type: "authorization_code"
    },
    accessTokenUrl: "https://gitlab.com/oauth/token",
    authorizationUrl: "https://gitlab.com/oauth/authorize?response_type=code",
    profileUrl: "https://gitlab.com/api/v4/user",

    profile(profile) {
      return {
        id: profile.id,
        name: profile.username,
        email: profile.email,
        image: profile.avatar_url
      };
    }

  }, options);
}